import * as React from 'react';
import { DatePicker } from './DatePicker';
import { IgrValueChangedEventArgs } from "./igr-value-changed-event-args";
import { IgrGotFocusEventArgs } from "./igr-got-focus-event-args";
import { IgrLostFocusEventArgs } from "./igr-lost-focus-event-args";
import { IgrInputChangeEventArgs } from "./igr-input-change-event-args";
import { IgrKeyEventArgs } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { DateFormats } from "./DateFormats";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
export declare class IgrDatePicker extends React.Component<IIgrDatePickerProps> {
    private _container;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _renderer;
    height: string;
    width: string;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    constructor(props: IIgrDatePickerProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    componentWillUnmount(): void;
    private _implementation;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): DatePicker;
    readonly i: DatePicker;
    private _datePicker;
    /**
 * Gets or Sets the property name that contains the values.
*/
    value: Date;
    /**
     * Gets or Sets the property name that contains the values.
    */
    today: Date;
    /**
     * Gets or Sets the property name that contains the label.
    */
    label: string;
    /**
     * Gets or sets the color to use for the text.
    */
    labelTextColor: string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    labelTextStyle: string;
    /**
     * Gets or Sets the property name that contains the placeholder.
    */
    placeholder: string;
    /**
     * Gets or Sets the property name that contains the MinDate.
    */
    minDate: Date;
    /**
     * Gets or Sets the property name that contains the MaxDate.
    */
    maxDate: Date;
    /**
     * Gets or sets the display density to use for the date pcicker.
    */
    density: ControlDisplayDensity;
    /**
     * Gets or sets the base built in theme to use for the date picker.
    */
    baseTheme: BaseControlTheme;
    /**
     * Gets or sets the font to use for the combobox.
    */
    textStyle: string;
    /**
     * Gets or Sets the text color
    */
    textColor: string;
    /**
     * Gets or Sets the text color
    */
    iconColor: string;
    /**
     * Gets or sets the ShowClearButton property to detirmine if the clear button is shown
    */
    showClearButton: boolean;
    /**
     * Gets or sets the ShowTodayButton property to detirmine if the today button is shown
    */
    showTodayButton: boolean;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    allowTextInput: boolean;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    openOnFocus: boolean;
    /**
     * Gets or sets the FirstDayOfWeek property to detirmine first day of the week
    */
    firstDayOfWeek: DayOfWeek;
    /**
     * Gets or sets the FirstWeekOfYear property to detirmine first week of the year
    */
    firstWeekOfYear: FirstWeek;
    /**
     * Gets or sets the ShowWeekNumbers property to detirmine if the week numbers are shown
    */
    showWeekNumbers: boolean;
    /**
     * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
    */
    dateFormat: DateFormats;
    /**
     * Gets or sets the Format property to detirmine the format of the date in the input
    */
    formatString: string;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    select(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _valueChanged;
    private _valueChanged_wrapped;
    /**
     * Called when date is selected.
    */
    valueChanged: (s: IgrDatePicker, e: IgrValueChangedEventArgs) => void;
    private _gotFocus;
    private _gotFocus_wrapped;
    gotFocus: (s: IgrDatePicker, e: IgrGotFocusEventArgs) => void;
    private _lostFocus;
    private _lostFocus_wrapped;
    lostFocus: (s: IgrDatePicker, e: IgrLostFocusEventArgs) => void;
    private _keyDown;
    private _keyDown_wrapped;
    keyDown: (s: IgrDatePicker, e: IgrKeyEventArgs) => void;
    private _changing;
    private _changing_wrapped;
    changing: (s: IgrDatePicker, e: IgrInputChangeEventArgs) => void;
}
export interface IIgrDatePickerProps {
    width?: string;
    height?: string;
    /**
 * Gets or Sets the property name that contains the values.
*/
    value?: Date;
    /**
     * Gets or Sets the property name that contains the values.
    */
    today?: Date;
    /**
     * Gets or Sets the property name that contains the label.
    */
    label?: string;
    /**
     * Gets or sets the color to use for the text.
    */
    labelTextColor?: string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    labelTextStyle?: string;
    /**
     * Gets or Sets the property name that contains the placeholder.
    */
    placeholder?: string;
    /**
     * Gets or Sets the property name that contains the MinDate.
    */
    minDate?: Date;
    /**
     * Gets or Sets the property name that contains the MaxDate.
    */
    maxDate?: Date;
    /**
     * Gets or sets the display density to use for the date pcicker.
    */
    density?: ControlDisplayDensity | string;
    /**
     * Gets or sets the base built in theme to use for the date picker.
    */
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    textStyle?: string;
    /**
     * Gets or Sets the text color
    */
    textColor?: string;
    /**
     * Gets or Sets the text color
    */
    iconColor?: string;
    /**
     * Gets or sets the ShowClearButton property to detirmine if the clear button is shown
    */
    showClearButton?: boolean | string;
    /**
     * Gets or sets the ShowTodayButton property to detirmine if the today button is shown
    */
    showTodayButton?: boolean | string;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    allowTextInput?: boolean | string;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    openOnFocus?: boolean | string;
    /**
     * Gets or sets the FirstDayOfWeek property to detirmine first day of the week
    */
    firstDayOfWeek?: DayOfWeek | string;
    /**
     * Gets or sets the FirstWeekOfYear property to detirmine first week of the year
    */
    firstWeekOfYear?: FirstWeek | string;
    /**
     * Gets or sets the ShowWeekNumbers property to detirmine if the week numbers are shown
    */
    showWeekNumbers?: boolean | string;
    /**
     * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
    */
    dateFormat?: DateFormats | string;
    /**
     * Gets or sets the Format property to detirmine the format of the date in the input
    */
    formatString?: string;
    /**
 * Called when date is selected.
*/
    valueChanged?: (s: IgrDatePicker, e: IgrValueChangedEventArgs) => void;
    gotFocus?: (s: IgrDatePicker, e: IgrGotFocusEventArgs) => void;
    lostFocus?: (s: IgrDatePicker, e: IgrLostFocusEventArgs) => void;
    keyDown?: (s: IgrDatePicker, e: IgrKeyEventArgs) => void;
    changing?: (s: IgrDatePicker, e: IgrInputChangeEventArgs) => void;
}
